''*****************************
''*  Counter Modules v1.0.1   *
''*  (C) 2006 Parallax, Inc.  *
''*****************************
'' Modified by Robert Humiston 12/4/6
'' Now uses external file written by Tracy Allen to generate multiple
'' wave shapes

CON

  _CLKMODE = XTAL1 + PLL16X
  _XINFREQ = 5_000_000


OBJ

  tv : "tv_text"
  kb : "keyboard"
  freqgen : "sine" 'replace sine with saw or triangle to change output
        
VAR

  long  ctr, frq
  word Stack1[360]
  word Stack2[60]
  word Stack3[200]
  long Frequency2

  
PUB Go
  dira[6]~~
  '' Synthesize frequencies on pin 0 and pin 1
  '' also show FRQ values on tv

                     'start tv terminal
  Cognew(MeasureFrequency_PinA5, @Stack2)
  Cognew(input,@Stack1)
  Frequency2 := 10000
  freqgen.start(10_000)
 

   'repeat 'SynthFreq(6, Frequency2)
    CTRA := ctr                        'set CTRA
    FRQA := frq                        'set FRQA                   
    DIRA[6]~~                          'make pin output
       'determine ctr and frq for pin 0
                      'waitcnt to reduce power
PRI MeasureFrequency_PinA5 | Pin, Frequency
  tv.start(12)
  TV.Str(string("      PROPELLER"))       'Displays string on tv
  tv.Str(string("  FREQUENCY COUNTER",13))   'Displays string on tv
  tv.Str(string("FREQ:"))                 'Displays string on tv
   Repeat
    Pin := 5
    DirA[Pin] := %0 
    CTRA := 0                                'Clear CTRA settings                 
    CTRA := (%01010 << 26 ) | (%001 << 23) | (0 << 9) | (Pin) 'Trigger to count
'                                                              rising edge on A5 
    FRQA := 1000                              'Count 1000 each trigger
    PHSA := 0                                 'Clear accumulated value
    WaitCNT( 40_000_000 + CNT )               'Wait for 1 second
    Frequency := PHSA / 2000                  'Calculate Freq based on duration,
'                                              1000 ms (1 second)
    tv.Str(string($A,5,$B,1))       
    tv.Dec(Frequency)                    'Displays freq in an 8 char field.
    tv.Str(string("Hz      "))
    tv.str(string($B,6,$A,1))
    tv.dec(Frequency2)
    tv.str(String("Hz        "))                     'Displays string on tv
 
PUB input | i     'start the keyboard
  kb.start(26, 27)

  repeat
    i := kb.newkey
    case i
      200,201 :if frequency2 < 1
                  frequency2 := 0
               else
                  Frequency2 /= 10
      48..57 :  if frequency2 < 1
                  frequency2 := i-48
                else
                  Frequency2 := Frequency2 * 10 +(i-48)
      other : frequency2:= i
    freqgen.update(frequency2)
   
     '(  
  
    
    